#line 1 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
/*
* Copyright (c) 2015-2017, Intel Corporation
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*  * Redistributions of source code must retain the above copyright notice,
*    this list of conditions and the following disclaimer.
*  * Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*  * Neither the name of Intel Corporation nor the names of its contributors
*    may be used to endorse or promote products derived from this software
*    without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*/

#include "config.h"

#include "ColliderCorporaParser.h"
#include "Corpora.h"

#include "ue2common.h"

#include <cassert>
#include <cstdlib>
#include <string>
#include <cstdio>

using namespace std;

namespace /* anonymous */ {
	
	// Take a string like '\xFF' and convert it to the character it represents
	char unhex(const char *start, UNUSED const char *end) {
		assert(start + 4 == end);
		assert(start[0] == '\\');
		assert(start[1] == 'x');
		assert(isxdigit(start[2]));
		assert(isxdigit(start[2]));
		
		char temp[3] = {start[2], start[3], 0};
		
		return strtol(temp, nullptr, 16);
	}
	
	
#line 61 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
	static const signed char _FileCorporaParser_actions[] = {
		0, 1, 0, 1, 3, 1, 4, 1,
		5, 1, 6, 1, 7, 1, 8, 1,
		9, 1, 10, 1, 11, 1, 12, 1,
		13, 1, 14, 1, 15, 1, 16, 1,
		17, 1, 18, 1, 19, 1, 20, 1,
		21, 1, 22, 1, 23, 1, 24, 2,
		0, 2, 2, 3, 0, 3, 1, 0,
		2, 0
	};
	
	static const signed char _FileCorporaParser_key_offsets[] = {
		0, 0, 2, 6, 7, 13, 19, 25,
		31, 34, 34, 35, 52, 54, 71, 72,
		75, 79, 0
	};
	
	static const char _FileCorporaParser_trans_keys[] = {
		48u, 57u, 58u, 61u, 48u, 57u, 34u, 48u,
		57u, 65u, 70u, 97u, 102u, 48u, 57u, 65u,
		70u, 97u, 102u, 48u, 57u, 65u, 70u, 97u,
		102u, 48u, 57u, 65u, 70u, 97u, 102u, 32u,
		48u, 57u, 92u, 48u, 97u, 110u, 114u, 116u,
		118u, 120u, 49u, 57u, 65u, 90u, 98u, 100u,
		101u, 102u, 103u, 122u, 34u, 92u, 48u, 97u,
		110u, 114u, 116u, 118u, 120u, 49u, 57u, 65u,
		90u, 98u, 100u, 101u, 102u, 103u, 122u, 58u,
		32u, 48u, 57u, 32u, 44u, 48u, 57u, 32u,
		44u, 0u
	};
	
	static const signed char _FileCorporaParser_single_lengths[] = {
		0, 0, 2, 1, 0, 0, 0, 0,
		1, 0, 1, 7, 2, 7, 1, 1,
		2, 2, 0
	};
	
	static const signed char _FileCorporaParser_range_lengths[] = {
		0, 1, 1, 0, 3, 3, 3, 3,
		1, 0, 0, 5, 0, 5, 0, 1,
		1, 0, 0
	};
	
	static const signed char _FileCorporaParser_index_offsets[] = {
		0, 0, 2, 6, 8, 12, 16, 20,
		24, 27, 28, 30, 43, 46, 59, 61,
		64, 68, 0
	};
	
	static const signed char _FileCorporaParser_cond_targs[] = {
		2, 0, 9, 3, 2, 0, 9, 0,
		5, 5, 5, 10, 10, 10, 10, 10,
		7, 7, 7, 12, 12, 12, 12, 12,
		8, 16, 0, 0, 11, 10, 10, 10,
		10, 10, 10, 10, 4, 10, 10, 10,
		10, 10, 10, 12, 13, 12, 12, 12,
		12, 12, 12, 12, 6, 12, 12, 12,
		12, 12, 12, 14, 0, 8, 16, 0,
		17, 15, 16, 15, 17, 15, 15, 0,
		1, 2, 3, 10, 10, 12, 12, 8,
		9, 10, 10, 12, 12, 14, 15, 15,
		15, 0
	};
	
	static const signed char _FileCorporaParser_cond_actions[] = {
		53, 0, 5, 0, 47, 0, 7, 0,
		0, 0, 0, 25, 15, 15, 15, 25,
		0, 0, 0, 39, 27, 27, 27, 39,
		0, 1, 0, 0, 13, 21, 17, 17,
		17, 17, 17, 17, 0, 23, 23, 23,
		17, 23, 19, 35, 13, 33, 29, 29,
		29, 29, 29, 29, 0, 37, 37, 37,
		29, 37, 31, 41, 0, 3, 50, 0,
		0, 43, 1, 45, 0, 43, 45, 0,
		0, 0, 0, 25, 25, 39, 39, 0,
		0, 0, 23, 0, 37, 0, 0, 45,
		45, 0
	};
	
	static const signed char _FileCorporaParser_to_state_actions[] = {
		0, 9, 0, 0, 0, 0, 0, 0,
		0, 0, 9, 0, 9, 0, 9, 9,
		0, 0, 0
	};
	
	static const signed char _FileCorporaParser_from_state_actions[] = {
		0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 11, 0, 11, 0, 11, 11,
		0, 0, 0
	};
	
	static const signed char _FileCorporaParser_eof_trans[] = {
		72, 73, 74, 75, 76, 77, 78, 79,
		80, 81, 82, 83, 84, 85, 86, 87,
		88, 89, 0
	};
	
	static const int FileCorporaParser_start = 1;
	static const int FileCorporaParser_first_final = 9;
	static const int FileCorporaParser_error = 0;
	
	static const int FileCorporaParser_en_corpus_old = 10;
	static const int FileCorporaParser_en_corpus_new = 12;
	static const int FileCorporaParser_en_colon_sep = 14;
	static const int FileCorporaParser_en_match_list = 15;
	static const int FileCorporaParser_en_main = 1;
	
	
#line 88 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
	
	
} // namespace

bool parseCorpus(const string &line, Corpus &c, unsigned int &id) {
	const char *p = line.c_str();
	const char *pe = p + line.size();
	const char *eof = pe;
	const char *ts;
	const char *te;
	int cs;
	UNUSED int act;
	
	// For storing integers as they're scanned
	unsigned int num = 0;
	
	string &sout = c.data;
	
	
#line 190 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
	{
		cs = (int)FileCorporaParser_start;
		ts = 0;
		te = 0;
	}
	
#line 197 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
	{
		int _klen;
		unsigned int _trans = 0;
		const char * _keys;
		const signed char * _acts;
		unsigned int _nacts;
		_resume: {}
		if ( p == pe && p != eof )
			goto _out;
		_acts = ( _FileCorporaParser_actions + (_FileCorporaParser_from_state_actions[cs]));
		_nacts = (unsigned int)(*( _acts));
		_acts += 1;
		while ( _nacts > 0 ) {
			switch ( (*( _acts)) ) {
				case 7:  {
					{
#line 1 "NONE"
						{ts = p;}}
					
#line 217 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
					
					break; 
				}
			}
			_nacts -= 1;
			_acts += 1;
		}
		
		if ( p == eof ) {
			if ( _FileCorporaParser_eof_trans[cs] > 0 ) {
				_trans = (unsigned int)_FileCorporaParser_eof_trans[cs] - 1;
			}
		}
		else {
			_keys = ( _FileCorporaParser_trans_keys + (_FileCorporaParser_key_offsets[cs]));
			_trans = (unsigned int)_FileCorporaParser_index_offsets[cs];
			
			_klen = (int)_FileCorporaParser_single_lengths[cs];
			if ( _klen > 0 ) {
				const char *_lower = _keys;
				const char *_upper = _keys + _klen - 1;
				const char *_mid;
				while ( 1 ) {
					if ( _upper < _lower ) {
						_keys += _klen;
						_trans += (unsigned int)_klen;
						break;
					}
					
					_mid = _lower + ((_upper-_lower) >> 1);
					if ( ( (*( p))) < (*( _mid)) )
						_upper = _mid - 1;
					else if ( ( (*( p))) > (*( _mid)) )
						_lower = _mid + 1;
					else {
						_trans += (unsigned int)(_mid - _keys);
						goto _match;
					}
				}
			}
			
			_klen = (int)_FileCorporaParser_range_lengths[cs];
			if ( _klen > 0 ) {
				const char *_lower = _keys;
				const char *_upper = _keys + (_klen<<1) - 2;
				const char *_mid;
				while ( 1 ) {
					if ( _upper < _lower ) {
						_trans += (unsigned int)_klen;
						break;
					}
					
					_mid = _lower + (((_upper-_lower) >> 1) & ~1);
					if ( ( (*( p))) < (*( _mid)) )
						_upper = _mid - 2;
					else if ( ( (*( p))) > (*( _mid + 1)) )
						_lower = _mid + 2;
					else {
						_trans += (unsigned int)((_mid - _keys)>>1);
						break;
					}
				}
			}
			
			_match: {}
		}
		cs = (int)_FileCorporaParser_cond_targs[_trans];
		
		if ( _FileCorporaParser_cond_actions[_trans] != 0 ) {
			
			_acts = ( _FileCorporaParser_actions + (_FileCorporaParser_cond_actions[_trans]));
			_nacts = (unsigned int)(*( _acts));
			_acts += 1;
			while ( _nacts > 0 ) {
				switch ( (*( _acts)) )
				{
					case 0:  {
						{
#line 61 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							
							num = (num * 10) + ((( (*( p)))) - '0');
						}
						
#line 301 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 1:  {
						{
#line 107 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							num = 0;}
						
#line 310 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 2:  {
						{
#line 107 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							id = num;}
						
#line 319 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 3:  {
						{
#line 133 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							num = 0;}
						
#line 328 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 4:  {
						{
#line 137 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{cs = 10;goto _again;}}
						
#line 337 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 5:  {
						{
#line 140 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							c.hasMatches = true; {cs = 12;goto _again;}}
						
#line 346 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 8:  {
						{
#line 1 "NONE"
							{te = p+1;}}
						
#line 355 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 9:  {
						{
#line 65 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 65 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									
									sout.push_back(unhex(ts, te));
								}
							}}
						
#line 369 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 10:  {
						{
#line 69 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 69 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									
									switch (*(ts+1)) {
										case '0': sout.push_back('\x00'); break;
										case 'a': sout.push_back('\x07'); break;
										case 'e': sout.push_back('\x1b'); break;
										case 'f': sout.push_back('\x0c'); break;
										case 'n': sout.push_back('\x0a'); break;
										case 'v': sout.push_back('\x0b'); break;
										case 'r': sout.push_back('\x0d'); break;
										case 't': sout.push_back('\x09'); break;
										default: {p += 1; goto _out; }
									}
								}
							}}
						
#line 393 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 11:  {
						{
#line 116 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 116 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									sout.push_back(*(ts + 1)); }
							}}
						
#line 405 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 12:  {
						{
#line 117 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 117 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									sout.push_back(*ts); }
							}}
						
#line 417 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 13:  {
						{
#line 117 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p;p = p - 1;{
#line 117 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									sout.push_back(*ts); }
							}}
						
#line 429 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 14:  {
						{
#line 117 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{p = ((te))-1;
								{
#line 117 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									sout.push_back(*ts); }
							}}
						
#line 442 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 15:  {
						{
#line 65 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 65 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									
									sout.push_back(unhex(ts, te));
								}
							}}
						
#line 456 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 16:  {
						{
#line 69 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 69 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									
									switch (*(ts+1)) {
										case '0': sout.push_back('\x00'); break;
										case 'a': sout.push_back('\x07'); break;
										case 'e': sout.push_back('\x1b'); break;
										case 'f': sout.push_back('\x0c'); break;
										case 'n': sout.push_back('\x0a'); break;
										case 'v': sout.push_back('\x0b'); break;
										case 'r': sout.push_back('\x0d'); break;
										case 't': sout.push_back('\x09'); break;
										default: {p += 1; goto _out; }
									}
								}
							}}
						
#line 480 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 17:  {
						{
#line 123 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 123 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									sout.push_back(*(ts + 1)); }
							}}
						
#line 492 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 18:  {
						{
#line 124 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 124 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									sout.push_back(*ts); }
							}}
						
#line 504 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 19:  {
						{
#line 125 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 125 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									{cs = 14;goto _again;}}
							}}
						
#line 516 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 20:  {
						{
#line 124 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p;p = p - 1;{
#line 124 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									sout.push_back(*ts); }
							}}
						
#line 528 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 21:  {
						{
#line 124 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{p = ((te))-1;
								{
#line 124 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									sout.push_back(*ts); }
							}}
						
#line 541 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 22:  {
						{
#line 129 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 129 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									{cs = 15;goto _again;}}
							}}
						
#line 553 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 23:  {
						{
#line 83 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p+1;{
#line 83 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									
									c.matches.insert(num);
								}
							}}
						
#line 567 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
					case 24:  {
						{
#line 83 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
							{te = p;p = p - 1;{
#line 83 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
									
									c.matches.insert(num);
								}
							}}
						
#line 581 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
				}
				_nacts -= 1;
				_acts += 1;
			}
			
		}
		
		_again: {}
		if ( p == eof ) {
			if ( cs >= 9 )
				goto _out;
		}
		else {
			_acts = ( _FileCorporaParser_actions + (_FileCorporaParser_to_state_actions[cs]));
			_nacts = (unsigned int)(*( _acts));
			_acts += 1;
			while ( _nacts > 0 ) {
				switch ( (*( _acts)) ) {
					case 6:  {
						{
#line 1 "NONE"
							{ts = 0;}}
						
#line 608 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/build/tools/hscollider//ColliderCorporaParser.cpp"
						
						break; 
					}
				}
				_nacts -= 1;
				_acts += 1;
			}
			
			if ( cs != 0 ) {
				p += 1;
				goto _resume;
			}
		}
		_out: {}
	}
	
#line 147 "/home/abuild/rpmbuild/BUILD/vectorscan-vectorscan-5.4.8/tools/hscollider/ColliderCorporaParser.rl"
	
	
	return (cs != FileCorporaParser_error) && (p == pe);
}
